library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity sramConnector is
	port(ats_inter_chipselect_n : in std_logic;
		ats_inter_outputenable_n: in std_logic;
		ats_inter_data : inout std_logic_vector (15 downto 0);
		ats_inter_address : in std_logic_vector (17 downto 0);
		ats_inter_byteenable_n : in std_logic_vector (1 downto 0);
		ats_inter_write_n : in std_logic; 
		coe_address_export : out std_logic_vector (17 downto 0);
		--coe_data_export : inout std_logic_vector (15 downto 0);
		coe_chipselect_export : out std_logic;
		coe_outputenable_export : out std_logic;
		coe_writeenable_export : out std_logic;
		coe_upperbyte_export : out std_logic;
		coe_lowerbyte_export : out std_logic);
end entity sramConnector;

architecture rtl of sramConnector is
	begin
	coe_address_export <= ats_inter_address;
	coe_chipselect_export <= ats_inter_chipselect_n;
	coe_outputenable_export <= ats_inter_outputenable_n;
	coe_writeenable_export <= ats_inter_write_n;
	coe_upperbyte_export <= ats_inter_byteenable_n (1);
	coe_lowerbyte_export <= ats_inter_byteenable_n(0);
	

end architecture rtl; 
